# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from clearpath_mission_scheduler_msgs/StorageState.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import clearpath_mission_scheduler_msgs.msg
import genpy

class StorageState(genpy.Message):
  _md5sum = "4fad6124bf8476f227ee3abc43294f25"
  _type = "clearpath_mission_scheduler_msgs/StorageState"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """clearpath_mission_scheduler_msgs/Schedule[] schedules

================================================================================
MSG: clearpath_mission_scheduler_msgs/Schedule
# Single-execution mode; the schedule starts at the designated time and runs once
uint8 MODE_ONCE=0

# Looping mode; the schedule starts at the designated time, and every loop_interval seconds after
# for the designated number of repeats
uint8 MODE_LOOP=1

# Single-shot execution, but does NOT get added to the persistent storage
# Equivalent to MODE_ONCE, but for one-off, throw-away schedules (e.g. "Run X in 5 minutes")
uint8 MODE_TRANSIENT=2

# The human-readable name for this schedule
# Should be unique, but there's no hard requirement for it to be so
string name

# The unique ID of this schedule
# A string of the form "12345678-90ab-cdef-1234-567890abcdef"
string uuid

# The time that this mission starts every day
clearpath_mission_scheduler_msgs/UtcTime start_time

# Either MODE_ONCE or MODE_LOOP to indicate the execution mode
uint8 mode

# In MODE_LOOP, how many times do we repeat the missions?
uint8 loop_repeats

# In MODE_LOOP, how long do we wait between executions?
duration loop_interval

# The ordered list of Mission UUIDs to execute
string[] mission_ids

# The minimum battery charge needed before we execute the missions
# Must be in the range 0-1
float32 min_battery

# If the missions take longer than this to execute, assume the schedule has failed and alert the user
# Set to zero to disable the timeout
duration timeout

# Is this schedule enabled?
# Only enabled schedules will execute
bool enabled

================================================================================
MSG: clearpath_mission_scheduler_msgs/UtcTime
# Represents a moment in time on a 24-hour clock

# The hour, 0-23
uint8 hour

# The minute, 0-59
uint8 minute

# The second, 0-59
uint8 second

# Milliseconds, 0-999 (not typically needed)
uint16 millisecond
"""
  __slots__ = ['schedules']
  _slot_types = ['clearpath_mission_scheduler_msgs/Schedule[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       schedules

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(StorageState, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.schedules is None:
        self.schedules = []
    else:
      self.schedules = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.schedules)
      buff.write(_struct_I.pack(length))
      for val1 in self.schedules:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v1 = val1.start_time
        _x = _v1
        buff.write(_get_struct_3BH().pack(_x.hour, _x.minute, _x.second, _x.millisecond))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.mode, _x.loop_repeats))
        _v2 = val1.loop_interval
        _x = _v2
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        length = len(val1.mission_ids)
        buff.write(_struct_I.pack(length))
        for val2 in val1.mission_ids:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          buff.write(struct.Struct('<I%ss'%length).pack(length, val2))
        _x = val1.min_battery
        buff.write(_get_struct_f().pack(_x))
        _v3 = val1.timeout
        _x = _v3
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _x = val1.enabled
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.schedules is None:
        self.schedules = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.schedules = []
      for i in range(0, length):
        val1 = clearpath_mission_scheduler_msgs.msg.Schedule()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.uuid = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.uuid = str[start:end]
        _v4 = val1.start_time
        _x = _v4
        start = end
        end += 5
        (_x.hour, _x.minute, _x.second, _x.millisecond,) = _get_struct_3BH().unpack(str[start:end])
        _x = val1
        start = end
        end += 2
        (_x.mode, _x.loop_repeats,) = _get_struct_2B().unpack(str[start:end])
        _v5 = val1.loop_interval
        _x = _v5
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.mission_ids = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2 = str[start:end]
          val1.mission_ids.append(val2)
        start = end
        end += 4
        (val1.min_battery,) = _get_struct_f().unpack(str[start:end])
        _v6 = val1.timeout
        _x = _v6
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        start = end
        end += 1
        (val1.enabled,) = _get_struct_B().unpack(str[start:end])
        val1.enabled = bool(val1.enabled)
        self.schedules.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.schedules)
      buff.write(_struct_I.pack(length))
      for val1 in self.schedules:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v7 = val1.start_time
        _x = _v7
        buff.write(_get_struct_3BH().pack(_x.hour, _x.minute, _x.second, _x.millisecond))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.mode, _x.loop_repeats))
        _v8 = val1.loop_interval
        _x = _v8
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        length = len(val1.mission_ids)
        buff.write(_struct_I.pack(length))
        for val2 in val1.mission_ids:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          buff.write(struct.Struct('<I%ss'%length).pack(length, val2))
        _x = val1.min_battery
        buff.write(_get_struct_f().pack(_x))
        _v9 = val1.timeout
        _x = _v9
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _x = val1.enabled
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.schedules is None:
        self.schedules = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.schedules = []
      for i in range(0, length):
        val1 = clearpath_mission_scheduler_msgs.msg.Schedule()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.uuid = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.uuid = str[start:end]
        _v10 = val1.start_time
        _x = _v10
        start = end
        end += 5
        (_x.hour, _x.minute, _x.second, _x.millisecond,) = _get_struct_3BH().unpack(str[start:end])
        _x = val1
        start = end
        end += 2
        (_x.mode, _x.loop_repeats,) = _get_struct_2B().unpack(str[start:end])
        _v11 = val1.loop_interval
        _x = _v11
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.mission_ids = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2 = str[start:end]
          val1.mission_ids.append(val2)
        start = end
        end += 4
        (val1.min_battery,) = _get_struct_f().unpack(str[start:end])
        _v12 = val1.timeout
        _x = _v12
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        start = end
        end += 1
        (val1.enabled,) = _get_struct_B().unpack(str[start:end])
        val1.enabled = bool(val1.enabled)
        self.schedules.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_2i = None
def _get_struct_2i():
    global _struct_2i
    if _struct_2i is None:
        _struct_2i = struct.Struct("<2i")
    return _struct_2i
_struct_3BH = None
def _get_struct_3BH():
    global _struct_3BH
    if _struct_3BH is None:
        _struct_3BH = struct.Struct("<3BH")
    return _struct_3BH
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_f = None
def _get_struct_f():
    global _struct_f
    if _struct_f is None:
        _struct_f = struct.Struct("<f")
    return _struct_f
