# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from clearpath_mission_scheduler_msgs/UpdateScheduleRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import clearpath_mission_scheduler_msgs.msg
import genpy

class UpdateScheduleRequest(genpy.Message):
  _md5sum = "9bdd01914ef4845fff5f02a7b6a94631"
  _type = "clearpath_mission_scheduler_msgs/UpdateScheduleRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# The ID of the mission to edit
string uuid

# The human-readable name for this schedule
# Should be unique, but there's no hard requirement for it to be so
string name

# The time that this mission starts every day
clearpath_mission_scheduler_msgs/UtcTime start_time

# Either Schedule.MODE_ONCE, Schedule.MODE_LOOP, OR Schedule.MODE_TRANSIENT to indicate the execution mode
uint8 mode

# In MODE_LOOP, how many times do we repeat the missions?
uint8 loop_repeats

# In MODE_LOOP, how long do we wait between executions?
duration loop_interval

# The ordered list of Mission UUIDs to execute
string[] mission_ids

# The minimum battery charge needed before we execute the missions
# Must be in the range 0-1
float32 min_battery

# If the missions take longer than this to execute, assume the schedule has failed and alert the user
# Set to zero to disable the timeout
duration timeout

# Is this schedule enabled?
# Only enabled schedules will execute
bool enabled


================================================================================
MSG: clearpath_mission_scheduler_msgs/UtcTime
# Represents a moment in time on a 24-hour clock

# The hour, 0-23
uint8 hour

# The minute, 0-59
uint8 minute

# The second, 0-59
uint8 second

# Milliseconds, 0-999 (not typically needed)
uint16 millisecond
"""
  __slots__ = ['uuid','name','start_time','mode','loop_repeats','loop_interval','mission_ids','min_battery','timeout','enabled']
  _slot_types = ['string','string','clearpath_mission_scheduler_msgs/UtcTime','uint8','uint8','duration','string[]','float32','duration','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       uuid,name,start_time,mode,loop_repeats,loop_interval,mission_ids,min_battery,timeout,enabled

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(UpdateScheduleRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.uuid is None:
        self.uuid = ''
      if self.name is None:
        self.name = ''
      if self.start_time is None:
        self.start_time = clearpath_mission_scheduler_msgs.msg.UtcTime()
      if self.mode is None:
        self.mode = 0
      if self.loop_repeats is None:
        self.loop_repeats = 0
      if self.loop_interval is None:
        self.loop_interval = genpy.Duration()
      if self.mission_ids is None:
        self.mission_ids = []
      if self.min_battery is None:
        self.min_battery = 0.
      if self.timeout is None:
        self.timeout = genpy.Duration()
      if self.enabled is None:
        self.enabled = False
    else:
      self.uuid = ''
      self.name = ''
      self.start_time = clearpath_mission_scheduler_msgs.msg.UtcTime()
      self.mode = 0
      self.loop_repeats = 0
      self.loop_interval = genpy.Duration()
      self.mission_ids = []
      self.min_battery = 0.
      self.timeout = genpy.Duration()
      self.enabled = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.uuid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3BH2B2i().pack(_x.start_time.hour, _x.start_time.minute, _x.start_time.second, _x.start_time.millisecond, _x.mode, _x.loop_repeats, _x.loop_interval.secs, _x.loop_interval.nsecs))
      length = len(self.mission_ids)
      buff.write(_struct_I.pack(length))
      for val1 in self.mission_ids:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self
      buff.write(_get_struct_f2iB().pack(_x.min_battery, _x.timeout.secs, _x.timeout.nsecs, _x.enabled))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.start_time is None:
        self.start_time = clearpath_mission_scheduler_msgs.msg.UtcTime()
      if self.loop_interval is None:
        self.loop_interval = genpy.Duration()
      if self.timeout is None:
        self.timeout = genpy.Duration()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.uuid = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.uuid = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      _x = self
      start = end
      end += 15
      (_x.start_time.hour, _x.start_time.minute, _x.start_time.second, _x.start_time.millisecond, _x.mode, _x.loop_repeats, _x.loop_interval.secs, _x.loop_interval.nsecs,) = _get_struct_3BH2B2i().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mission_ids = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.mission_ids.append(val1)
      _x = self
      start = end
      end += 13
      (_x.min_battery, _x.timeout.secs, _x.timeout.nsecs, _x.enabled,) = _get_struct_f2iB().unpack(str[start:end])
      self.enabled = bool(self.enabled)
      self.loop_interval.canon()
      self.timeout.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.uuid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3BH2B2i().pack(_x.start_time.hour, _x.start_time.minute, _x.start_time.second, _x.start_time.millisecond, _x.mode, _x.loop_repeats, _x.loop_interval.secs, _x.loop_interval.nsecs))
      length = len(self.mission_ids)
      buff.write(_struct_I.pack(length))
      for val1 in self.mission_ids:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self
      buff.write(_get_struct_f2iB().pack(_x.min_battery, _x.timeout.secs, _x.timeout.nsecs, _x.enabled))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.start_time is None:
        self.start_time = clearpath_mission_scheduler_msgs.msg.UtcTime()
      if self.loop_interval is None:
        self.loop_interval = genpy.Duration()
      if self.timeout is None:
        self.timeout = genpy.Duration()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.uuid = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.uuid = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      _x = self
      start = end
      end += 15
      (_x.start_time.hour, _x.start_time.minute, _x.start_time.second, _x.start_time.millisecond, _x.mode, _x.loop_repeats, _x.loop_interval.secs, _x.loop_interval.nsecs,) = _get_struct_3BH2B2i().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mission_ids = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.mission_ids.append(val1)
      _x = self
      start = end
      end += 13
      (_x.min_battery, _x.timeout.secs, _x.timeout.nsecs, _x.enabled,) = _get_struct_f2iB().unpack(str[start:end])
      self.enabled = bool(self.enabled)
      self.loop_interval.canon()
      self.timeout.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3BH2B2i = None
def _get_struct_3BH2B2i():
    global _struct_3BH2B2i
    if _struct_3BH2B2i is None:
        _struct_3BH2B2i = struct.Struct("<3BH2B2i")
    return _struct_3BH2B2i
_struct_f2iB = None
def _get_struct_f2iB():
    global _struct_f2iB
    if _struct_f2iB is None:
        _struct_f2iB = struct.Struct("<f2iB")
    return _struct_f2iB
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from clearpath_mission_scheduler_msgs/UpdateScheduleResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import clearpath_mission_scheduler_msgs.msg
import genpy

class UpdateScheduleResponse(genpy.Message):
  _md5sum = "e3bb4406a57e6260afc851e9ecf6d0c7"
  _type = "clearpath_mission_scheduler_msgs/UpdateScheduleResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """
# The modified mission, as-saved on disk
clearpath_mission_scheduler_msgs/Schedule result


================================================================================
MSG: clearpath_mission_scheduler_msgs/Schedule
# Single-execution mode; the schedule starts at the designated time and runs once
uint8 MODE_ONCE=0

# Looping mode; the schedule starts at the designated time, and every loop_interval seconds after
# for the designated number of repeats
uint8 MODE_LOOP=1

# Single-shot execution, but does NOT get added to the persistent storage
# Equivalent to MODE_ONCE, but for one-off, throw-away schedules (e.g. "Run X in 5 minutes")
uint8 MODE_TRANSIENT=2

# The human-readable name for this schedule
# Should be unique, but there's no hard requirement for it to be so
string name

# The unique ID of this schedule
# A string of the form "12345678-90ab-cdef-1234-567890abcdef"
string uuid

# The time that this mission starts every day
clearpath_mission_scheduler_msgs/UtcTime start_time

# Either MODE_ONCE or MODE_LOOP to indicate the execution mode
uint8 mode

# In MODE_LOOP, how many times do we repeat the missions?
uint8 loop_repeats

# In MODE_LOOP, how long do we wait between executions?
duration loop_interval

# The ordered list of Mission UUIDs to execute
string[] mission_ids

# The minimum battery charge needed before we execute the missions
# Must be in the range 0-1
float32 min_battery

# If the missions take longer than this to execute, assume the schedule has failed and alert the user
# Set to zero to disable the timeout
duration timeout

# Is this schedule enabled?
# Only enabled schedules will execute
bool enabled

================================================================================
MSG: clearpath_mission_scheduler_msgs/UtcTime
# Represents a moment in time on a 24-hour clock

# The hour, 0-23
uint8 hour

# The minute, 0-59
uint8 minute

# The second, 0-59
uint8 second

# Milliseconds, 0-999 (not typically needed)
uint16 millisecond
"""
  __slots__ = ['result']
  _slot_types = ['clearpath_mission_scheduler_msgs/Schedule']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       result

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(UpdateScheduleResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.result is None:
        self.result = clearpath_mission_scheduler_msgs.msg.Schedule()
    else:
      self.result = clearpath_mission_scheduler_msgs.msg.Schedule()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.result.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.result.uuid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3BH2B2i().pack(_x.result.start_time.hour, _x.result.start_time.minute, _x.result.start_time.second, _x.result.start_time.millisecond, _x.result.mode, _x.result.loop_repeats, _x.result.loop_interval.secs, _x.result.loop_interval.nsecs))
      length = len(self.result.mission_ids)
      buff.write(_struct_I.pack(length))
      for val1 in self.result.mission_ids:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self
      buff.write(_get_struct_f2iB().pack(_x.result.min_battery, _x.result.timeout.secs, _x.result.timeout.nsecs, _x.result.enabled))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.result is None:
        self.result = clearpath_mission_scheduler_msgs.msg.Schedule()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.result.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.result.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.result.uuid = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.result.uuid = str[start:end]
      _x = self
      start = end
      end += 15
      (_x.result.start_time.hour, _x.result.start_time.minute, _x.result.start_time.second, _x.result.start_time.millisecond, _x.result.mode, _x.result.loop_repeats, _x.result.loop_interval.secs, _x.result.loop_interval.nsecs,) = _get_struct_3BH2B2i().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.result.mission_ids = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.result.mission_ids.append(val1)
      _x = self
      start = end
      end += 13
      (_x.result.min_battery, _x.result.timeout.secs, _x.result.timeout.nsecs, _x.result.enabled,) = _get_struct_f2iB().unpack(str[start:end])
      self.result.enabled = bool(self.result.enabled)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.result.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.result.uuid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3BH2B2i().pack(_x.result.start_time.hour, _x.result.start_time.minute, _x.result.start_time.second, _x.result.start_time.millisecond, _x.result.mode, _x.result.loop_repeats, _x.result.loop_interval.secs, _x.result.loop_interval.nsecs))
      length = len(self.result.mission_ids)
      buff.write(_struct_I.pack(length))
      for val1 in self.result.mission_ids:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self
      buff.write(_get_struct_f2iB().pack(_x.result.min_battery, _x.result.timeout.secs, _x.result.timeout.nsecs, _x.result.enabled))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.result is None:
        self.result = clearpath_mission_scheduler_msgs.msg.Schedule()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.result.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.result.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.result.uuid = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.result.uuid = str[start:end]
      _x = self
      start = end
      end += 15
      (_x.result.start_time.hour, _x.result.start_time.minute, _x.result.start_time.second, _x.result.start_time.millisecond, _x.result.mode, _x.result.loop_repeats, _x.result.loop_interval.secs, _x.result.loop_interval.nsecs,) = _get_struct_3BH2B2i().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.result.mission_ids = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.result.mission_ids.append(val1)
      _x = self
      start = end
      end += 13
      (_x.result.min_battery, _x.result.timeout.secs, _x.result.timeout.nsecs, _x.result.enabled,) = _get_struct_f2iB().unpack(str[start:end])
      self.result.enabled = bool(self.result.enabled)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3BH2B2i = None
def _get_struct_3BH2B2i():
    global _struct_3BH2B2i
    if _struct_3BH2B2i is None:
        _struct_3BH2B2i = struct.Struct("<3BH2B2i")
    return _struct_3BH2B2i
_struct_f2iB = None
def _get_struct_f2iB():
    global _struct_f2iB
    if _struct_f2iB is None:
        _struct_f2iB = struct.Struct("<f2iB")
    return _struct_f2iB
class UpdateSchedule(object):
  _type          = 'clearpath_mission_scheduler_msgs/UpdateSchedule'
  _md5sum = '74908a4d416d18d79d5781adadbabb1e'
  _request_class  = UpdateScheduleRequest
  _response_class = UpdateScheduleResponse
