// Auto-generated. Do not edit!

// (in-package clearpath_mission_scheduler_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let UtcTime = require('./UtcTime.js');

//-----------------------------------------------------------

class Schedule {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.name = null;
      this.uuid = null;
      this.start_time = null;
      this.mode = null;
      this.loop_repeats = null;
      this.loop_interval = null;
      this.mission_ids = null;
      this.min_battery = null;
      this.timeout = null;
      this.enabled = null;
    }
    else {
      if (initObj.hasOwnProperty('name')) {
        this.name = initObj.name
      }
      else {
        this.name = '';
      }
      if (initObj.hasOwnProperty('uuid')) {
        this.uuid = initObj.uuid
      }
      else {
        this.uuid = '';
      }
      if (initObj.hasOwnProperty('start_time')) {
        this.start_time = initObj.start_time
      }
      else {
        this.start_time = new UtcTime();
      }
      if (initObj.hasOwnProperty('mode')) {
        this.mode = initObj.mode
      }
      else {
        this.mode = 0;
      }
      if (initObj.hasOwnProperty('loop_repeats')) {
        this.loop_repeats = initObj.loop_repeats
      }
      else {
        this.loop_repeats = 0;
      }
      if (initObj.hasOwnProperty('loop_interval')) {
        this.loop_interval = initObj.loop_interval
      }
      else {
        this.loop_interval = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('mission_ids')) {
        this.mission_ids = initObj.mission_ids
      }
      else {
        this.mission_ids = [];
      }
      if (initObj.hasOwnProperty('min_battery')) {
        this.min_battery = initObj.min_battery
      }
      else {
        this.min_battery = 0.0;
      }
      if (initObj.hasOwnProperty('timeout')) {
        this.timeout = initObj.timeout
      }
      else {
        this.timeout = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('enabled')) {
        this.enabled = initObj.enabled
      }
      else {
        this.enabled = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Schedule
    // Serialize message field [name]
    bufferOffset = _serializer.string(obj.name, buffer, bufferOffset);
    // Serialize message field [uuid]
    bufferOffset = _serializer.string(obj.uuid, buffer, bufferOffset);
    // Serialize message field [start_time]
    bufferOffset = UtcTime.serialize(obj.start_time, buffer, bufferOffset);
    // Serialize message field [mode]
    bufferOffset = _serializer.uint8(obj.mode, buffer, bufferOffset);
    // Serialize message field [loop_repeats]
    bufferOffset = _serializer.uint8(obj.loop_repeats, buffer, bufferOffset);
    // Serialize message field [loop_interval]
    bufferOffset = _serializer.duration(obj.loop_interval, buffer, bufferOffset);
    // Serialize message field [mission_ids]
    bufferOffset = _arraySerializer.string(obj.mission_ids, buffer, bufferOffset, null);
    // Serialize message field [min_battery]
    bufferOffset = _serializer.float32(obj.min_battery, buffer, bufferOffset);
    // Serialize message field [timeout]
    bufferOffset = _serializer.duration(obj.timeout, buffer, bufferOffset);
    // Serialize message field [enabled]
    bufferOffset = _serializer.bool(obj.enabled, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Schedule
    let len;
    let data = new Schedule(null);
    // Deserialize message field [name]
    data.name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [uuid]
    data.uuid = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [start_time]
    data.start_time = UtcTime.deserialize(buffer, bufferOffset);
    // Deserialize message field [mode]
    data.mode = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [loop_repeats]
    data.loop_repeats = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [loop_interval]
    data.loop_interval = _deserializer.duration(buffer, bufferOffset);
    // Deserialize message field [mission_ids]
    data.mission_ids = _arrayDeserializer.string(buffer, bufferOffset, null)
    // Deserialize message field [min_battery]
    data.min_battery = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [timeout]
    data.timeout = _deserializer.duration(buffer, bufferOffset);
    // Deserialize message field [enabled]
    data.enabled = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.name);
    length += _getByteLength(object.uuid);
    object.mission_ids.forEach((val) => {
      length += 4 + _getByteLength(val);
    });
    return length + 40;
  }

  static datatype() {
    // Returns string type for a message object
    return 'clearpath_mission_scheduler_msgs/Schedule';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'a49e4c67c4d109f364f626ea304adbf2';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Single-execution mode; the schedule starts at the designated time and runs once
    uint8 MODE_ONCE=0
    
    # Looping mode; the schedule starts at the designated time, and every loop_interval seconds after
    # for the designated number of repeats
    uint8 MODE_LOOP=1
    
    # Single-shot execution, but does NOT get added to the persistent storage
    # Equivalent to MODE_ONCE, but for one-off, throw-away schedules (e.g. "Run X in 5 minutes")
    uint8 MODE_TRANSIENT=2
    
    # The human-readable name for this schedule
    # Should be unique, but there's no hard requirement for it to be so
    string name
    
    # The unique ID of this schedule
    # A string of the form "12345678-90ab-cdef-1234-567890abcdef"
    string uuid
    
    # The time that this mission starts every day
    clearpath_mission_scheduler_msgs/UtcTime start_time
    
    # Either MODE_ONCE or MODE_LOOP to indicate the execution mode
    uint8 mode
    
    # In MODE_LOOP, how many times do we repeat the missions?
    uint8 loop_repeats
    
    # In MODE_LOOP, how long do we wait between executions?
    duration loop_interval
    
    # The ordered list of Mission UUIDs to execute
    string[] mission_ids
    
    # The minimum battery charge needed before we execute the missions
    # Must be in the range 0-1
    float32 min_battery
    
    # If the missions take longer than this to execute, assume the schedule has failed and alert the user
    # Set to zero to disable the timeout
    duration timeout
    
    # Is this schedule enabled?
    # Only enabled schedules will execute
    bool enabled
    
    ================================================================================
    MSG: clearpath_mission_scheduler_msgs/UtcTime
    # Represents a moment in time on a 24-hour clock
    
    # The hour, 0-23
    uint8 hour
    
    # The minute, 0-59
    uint8 minute
    
    # The second, 0-59
    uint8 second
    
    # Milliseconds, 0-999 (not typically needed)
    uint16 millisecond
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Schedule(null);
    if (msg.name !== undefined) {
      resolved.name = msg.name;
    }
    else {
      resolved.name = ''
    }

    if (msg.uuid !== undefined) {
      resolved.uuid = msg.uuid;
    }
    else {
      resolved.uuid = ''
    }

    if (msg.start_time !== undefined) {
      resolved.start_time = UtcTime.Resolve(msg.start_time)
    }
    else {
      resolved.start_time = new UtcTime()
    }

    if (msg.mode !== undefined) {
      resolved.mode = msg.mode;
    }
    else {
      resolved.mode = 0
    }

    if (msg.loop_repeats !== undefined) {
      resolved.loop_repeats = msg.loop_repeats;
    }
    else {
      resolved.loop_repeats = 0
    }

    if (msg.loop_interval !== undefined) {
      resolved.loop_interval = msg.loop_interval;
    }
    else {
      resolved.loop_interval = {secs: 0, nsecs: 0}
    }

    if (msg.mission_ids !== undefined) {
      resolved.mission_ids = msg.mission_ids;
    }
    else {
      resolved.mission_ids = []
    }

    if (msg.min_battery !== undefined) {
      resolved.min_battery = msg.min_battery;
    }
    else {
      resolved.min_battery = 0.0
    }

    if (msg.timeout !== undefined) {
      resolved.timeout = msg.timeout;
    }
    else {
      resolved.timeout = {secs: 0, nsecs: 0}
    }

    if (msg.enabled !== undefined) {
      resolved.enabled = msg.enabled;
    }
    else {
      resolved.enabled = false
    }

    return resolved;
    }
};

// Constants for message
Schedule.Constants = {
  MODE_ONCE: 0,
  MODE_LOOP: 1,
  MODE_TRANSIENT: 2,
}

module.exports = Schedule;
