// Auto-generated. Do not edit!

// (in-package clearpath_mission_scheduler_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

let StorageState = require('../msg/StorageState.js');

//-----------------------------------------------------------

class ImportDataRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.data = null;
    }
    else {
      if (initObj.hasOwnProperty('data')) {
        this.data = initObj.data
      }
      else {
        this.data = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ImportDataRequest
    // Serialize message field [data]
    bufferOffset = _serializer.string(obj.data, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ImportDataRequest
    let len;
    let data = new ImportDataRequest(null);
    // Deserialize message field [data]
    data.data = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.data);
    return length + 4;
  }

  static datatype() {
    // Returns string type for a service object
    return 'clearpath_mission_scheduler_msgs/ImportDataRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '992ce8a1687cec8c8bd883ec73ca41d1';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # A JSON string representing the database contents.
    # This is the same as the data output by the ExportData service, and is intended
    # to be used to restore the database to a previous state
    string data
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ImportDataRequest(null);
    if (msg.data !== undefined) {
      resolved.data = msg.data;
    }
    else {
      resolved.data = ''
    }

    return resolved;
    }
};

class ImportDataResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.state = null;
    }
    else {
      if (initObj.hasOwnProperty('state')) {
        this.state = initObj.state
      }
      else {
        this.state = new StorageState();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ImportDataResponse
    // Serialize message field [state]
    bufferOffset = StorageState.serialize(obj.state, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ImportDataResponse
    let len;
    let data = new ImportDataResponse(null);
    // Deserialize message field [state]
    data.state = StorageState.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += StorageState.getMessageSize(object.state);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'clearpath_mission_scheduler_msgs/ImportDataResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'b12baea2ad03f8106c0504855112105e';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # The state of the database after importing the data
    clearpath_mission_scheduler_msgs/StorageState state
    
    
    ================================================================================
    MSG: clearpath_mission_scheduler_msgs/StorageState
    clearpath_mission_scheduler_msgs/Schedule[] schedules
    
    ================================================================================
    MSG: clearpath_mission_scheduler_msgs/Schedule
    # Single-execution mode; the schedule starts at the designated time and runs once
    uint8 MODE_ONCE=0
    
    # Looping mode; the schedule starts at the designated time, and every loop_interval seconds after
    # for the designated number of repeats
    uint8 MODE_LOOP=1
    
    # Single-shot execution, but does NOT get added to the persistent storage
    # Equivalent to MODE_ONCE, but for one-off, throw-away schedules (e.g. "Run X in 5 minutes")
    uint8 MODE_TRANSIENT=2
    
    # The human-readable name for this schedule
    # Should be unique, but there's no hard requirement for it to be so
    string name
    
    # The unique ID of this schedule
    # A string of the form "12345678-90ab-cdef-1234-567890abcdef"
    string uuid
    
    # The time that this mission starts every day
    clearpath_mission_scheduler_msgs/UtcTime start_time
    
    # Either MODE_ONCE or MODE_LOOP to indicate the execution mode
    uint8 mode
    
    # In MODE_LOOP, how many times do we repeat the missions?
    uint8 loop_repeats
    
    # In MODE_LOOP, how long do we wait between executions?
    duration loop_interval
    
    # The ordered list of Mission UUIDs to execute
    string[] mission_ids
    
    # The minimum battery charge needed before we execute the missions
    # Must be in the range 0-1
    float32 min_battery
    
    # If the missions take longer than this to execute, assume the schedule has failed and alert the user
    # Set to zero to disable the timeout
    duration timeout
    
    # Is this schedule enabled?
    # Only enabled schedules will execute
    bool enabled
    
    ================================================================================
    MSG: clearpath_mission_scheduler_msgs/UtcTime
    # Represents a moment in time on a 24-hour clock
    
    # The hour, 0-23
    uint8 hour
    
    # The minute, 0-59
    uint8 minute
    
    # The second, 0-59
    uint8 second
    
    # Milliseconds, 0-999 (not typically needed)
    uint16 millisecond
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ImportDataResponse(null);
    if (msg.state !== undefined) {
      resolved.state = StorageState.Resolve(msg.state)
    }
    else {
      resolved.state = new StorageState()
    }

    return resolved;
    }
};

module.exports = {
  Request: ImportDataRequest,
  Response: ImportDataResponse,
  md5sum() { return '7627e30905e2fe27b9de1680a57108e1'; },
  datatype() { return 'clearpath_mission_scheduler_msgs/ImportData'; }
};
